from numpy import *
from pylab import *

# Results for avidin-biotin complex 

Vfem = 81.466*100.142*89.268 
Nfem = array([129*129*97,161*161*129,193*193*161,257*257*193,385*385*257,449*449*385])
Elfem = Nfem/Vfem

Elbem  = array([2.8, 4.1, 7.7, 15.1, 30.4])

# Esolv

EbindPyGmulti = array([103.62,87.52,83.8,77.62,75.66])
EsolvPyGmulti_com = array([-3689.37,-3479.63,-3446.99,-3432.4,-3426.])
EsolvPyGmulti_rec = array([-2239.56,-2082.28,-2062.1,-2050.41,-2044.88])
EsolvPyGmulti_lig = array([-1313.95,-1245.39,-1229.21,-1220.13,-1217.3])

EbindPyGsingl = array([101.8,86.61,82.5,75.58,75.48])
EsolvPyGsingl_com = array([-3681.44,-3470.48,-3436.35,-3419.32,-3411.54])
EsolvPyGsingl_rec = array([-2225.43,-2068.06,-2046.01,-2031.26,-2026.28])
EsolvPyGsingl_lig = array([-1318.33,-1249.55,-1233.36,-1224.16,-1221.26])

EbindAPB = array([117.11,95.73,76.2,81.18,78.9,76.43])
EsolvAPB_com = array([-3627.13,-3586.77,-3556.67,-3526,-3483.45,-3455.61])
EsolvAPB_rec = array([-2221.8,-2168.72,-2137.25,-2116.98,-2085.7,-2064.67])
EsolvAPB_lig = array([-1282.96,-1274.3,-1256.14,-1250.72,-1237.17,-1227.89])


# Time
timePyGmulti_com = array([89.62,158.88,285.1,517.4,1589.6])
timePyGmulti_rec = array([116.55,132.68,258.08,477.85,1473.04])
timePyGmulti_lig = array([18.56,24.3,46.16,96.5,195.44])
timePyGsingl_com = array([27.59,42.69,77.13,177,336.9])
timePyGsingl_rec = array([35.77,37.96,79.87,157.21,360.62])
timePyGsingl_lig = array([7.04,8.74,15.58,34.52,68.65])
timeAPB_com = array([14.9,23.73,39.77,67.46,199.73,428.95])
timeAPB_rec = array([12.8,21.96,36.93,64.6,182.3,420.1])
timeAPB_lig = array([6.75,13.42,25.96,50,169.82,315.6])

font = {'family':'serif','size':7}
figure(figsize=(3,2), dpi=80)
rc('font',**font)
PyGbind_multi_ext = 74.42
PyGbind_single_ext= 78.15

xmax = Elfem[-1]*5
xmin = Elfem[0]/1.5

#### Binding energy
semilogx(Elbem, EbindPyGmulti, c='k', marker='o', mfc='w', ms=3,ls='-',lw=0.5, label='PyGBe multi')
semilogx(Elbem, EbindPyGsingl, c='k', marker='s', mfc='w', ms=3,ls='-',lw=0.5, label='PyGBe single')
semilogx(Elfem, EbindAPB, c='k', marker='^', mfc='w', ms=3,ls='-',lw=0.5, label='APBS')

semilogx([xmin,1000],PyGbind_multi_ext*ones(2), c='k', marker='', mfc='w', ms=1, ls='dotted',lw=0.2)
semilogx([xmin,1000],PyGbind_single_ext*ones(2), c='k', marker='', mfc='w', ms=1, ls='dotted',lw=0.2)
ylabel('$\Delta G_{bind}$ [kJ/mol]', fontsize=10)
xlabel('Mesh density',fontsize=10)
text(1.5,72.0,'PyGBe mult surf ext',fontsize=6,rotation=0)
text(70, 78.5,'PyGBe sing surf ext',fontsize=6,rotation=0)
subplots_adjust(left=0.22, bottom=0.21, right=0.96, top=0.95)
axis([xmin,1000,70,120])
legend(loc='upper right')
savefig('Ebind_bpti.pdf')
clf()

#### Complex
PyGsolv_multi_ext_com = -3421
PyGsolv_singl_ext_com = -3405
APBsolv_ext_com = -3384.08
semilogx(Elbem, EsolvPyGmulti_com, c='k', marker='o', mfc='w', ms=3,ls='-',lw=0.5, label='PyGBe multi')
semilogx(Elbem, EsolvPyGsingl_com, c='k', marker='s', mfc='w', ms=3,ls='-',lw=0.5, label='PyGBe single')
semilogx(Elfem, EsolvAPB_com, c='k', marker='^', mfc='w', ms=3,ls='-',lw=0.5, label='APBS')

semilogx([xmin,xmax],PyGsolv_multi_ext_com*ones(2), c='k', marker='', mfc='w', ms=1, ls='dotted',lw=0.2)
semilogx([xmin,xmax],PyGsolv_singl_ext_com*ones(2), c='k', marker='', mfc='w', ms=1, ls='dotted',lw=0.2)
semilogx([xmin,xmax],APBsolv_ext_com*ones(2), c='k', marker='', mfc='w', ms=1, ls='dotted',lw=0.2)
ylabel('$\Delta G_{solv}$ [kJ/mol]', fontsize=10)
xlabel('Mesh density',fontsize=10)
text(100, -3382,'APBS extrap.',fontsize=6,rotation=0)
text(2, -3403,'PyGBe single extrap.',fontsize=6,rotation=0)
text(40, -3437,'PyGBe multi extrap.',fontsize=6,rotation=0)
subplots_adjust(left=0.22, bottom=0.21, right=0.96, top=0.95)
axis([xmin,xmax,-3700,-3350])
legend(loc='lower right')
savefig('Esolv_bpti_com.pdf')
clf()

APBerr = abs(EsolvAPB_com-APBsolv_ext_com)/abs(APBsolv_ext_com)
PyGerr_multi = abs(EsolvPyGmulti_com-PyGsolv_multi_ext_com)/abs(PyGsolv_multi_ext_com)
PyGerr_singl = abs(EsolvPyGsingl_com-PyGsolv_singl_ext_com)/abs(PyGsolv_singl_ext_com)
loglog(Elbem, PyGerr_multi, c='k', marker='o', mfc='w', ms=3, ls='', lw=0.5, label='PyGBe mult')
loglog(Elbem, PyGerr_singl, c='k', marker='s', mfc='w', ms=3, ls='', lw=0.5, label='PyGBe sing')
loglog(Elfem, APBerr, c='k', marker='^', mfc='w', ms=3, ls='', lw=0.5, label='APBS')
loglog(Elbem, 1./Elbem*1e-1, c='k', marker='', mfc='w', ms=3, ls=':', lw=0.8, label=None)
loglog(Elfem, 1./(Elfem)**(1./3)*1e-1, c='k', marker='', mfc='w', ms=3, ls=':', lw=0.8, label=None)
text(1e1, 1e-2,'area',fontsize=6,rotation=-48)
text(11, 3.5e-2,'mesh spacing',fontsize=6,rotation=-21)
axis([1,2e3,1e-3,1e-1])
ylabel('Error', fontsize=10)
xlabel('Mesh density',fontsize=10)
subplots_adjust(left=0.22, bottom=0.21, right=0.96, top=0.95)
legend(loc='lower right')
savefig('Error_bpti_com.pdf')
clf()

loglog(PyGerr_multi, timePyGmulti_com, c='k', marker='o', mfc='w', ms=5, ls='-',lw=0.5,label='PyGBe mult')
loglog(PyGerr_singl, timePyGsingl_com, c='k', marker='s', mfc='w', ms=5, ls='-',lw=0.5,label='PyGBe sing')
loglog(APBerr, timeAPB_com, c='k', marker='^', mfc='w', ms=5, ls='-',lw=0.5,label='APBS')
subplots_adjust(left=0.19, bottom=0.21, right=0.96, top=0.95)
ylabel('Time to solution [s]',fontsize=10)
xlabel('Error',fontsize=10)
#axis([3e-3,1e-1,1e1,1e4])
legend(loc='upper right')
savefig('time_com.pdf')
clf()

#### Receptor
PyGsolv_multi_ext_rec = -2039.92
PyGsolv_singl_ext_rec = -2023.74
APBsolv_ext_rec = -2037.88
semilogx(Elbem, EsolvPyGmulti_rec, c='k', marker='o', mfc='w', ms=3,ls='-',lw=0.5, label='PyGBe multi')
semilogx(Elbem, EsolvPyGsingl_rec, c='k', marker='s', mfc='w', ms=3,ls='-',lw=0.5, label='PyGBe single')
semilogx(Elfem, EsolvAPB_rec, c='k', marker='^', mfc='w', ms=3,ls='-',lw=0.5, label='APBS')

semilogx([xmin,xmax],PyGsolv_multi_ext_rec*ones(2), c='k', marker='', mfc='w', ms=1, ls='dotted',lw=0.2)
semilogx([xmin,xmax],PyGsolv_singl_ext_rec*ones(2), c='k', marker='', mfc='w', ms=1, ls='dotted',lw=0.2)
semilogx([xmin,xmax],APBsolv_ext_rec*ones(2), c='k', marker='', mfc='w', ms=1, ls='dotted',lw=0.2)
ylabel('$\Delta G_{solv}$ [kJ/mol]', fontsize=10)
xlabel('Mesh density',fontsize=10)
text(90, -2037,'APBS extrap.',fontsize=6,rotation=0)
text(2, -2023,'PyGBe single extrap.',fontsize=6,rotation=0)
text(50, -2051,'PyGBe multi extrap.',fontsize=6,rotation=0)
subplots_adjust(left=0.22, bottom=0.21, right=0.96, top=0.95)
axis([xmin,xmax,-2250,-2000])
legend(loc='lower right')
savefig('Esolv_bpti_rec.pdf')
clf()

APBerr = abs(EsolvAPB_rec-APBsolv_ext_rec)/abs(APBsolv_ext_rec)
PyGerr_multi = abs(EsolvPyGmulti_rec-PyGsolv_multi_ext_rec)/abs(PyGsolv_multi_ext_rec)
PyGerr_singl = abs(EsolvPyGsingl_rec-PyGsolv_singl_ext_rec)/abs(PyGsolv_singl_ext_rec)
loglog(Elbem, PyGerr_multi, c='k', marker='o', mfc='w', ms=3, ls='', lw=0.5, label='PyGBe mult')
loglog(Elbem, PyGerr_singl, c='k', marker='s', mfc='w', ms=3, ls='', lw=0.5, label='PyGBe sing')
loglog(Elfem, APBerr, c='k', marker='^', mfc='w', ms=3, ls='', lw=0.5, label='APBS')
loglog(Elbem, 1./Elbem*1e-1, c='k', marker='', mfc='w', ms=3, ls=':', lw=0.8, label=None)
loglog(Elfem, 1./(Elfem)**(1./3)*1e-1, c='k', marker='', mfc='w', ms=3, ls=':', lw=0.8, label=None)
text(1e1, 1e-2,'area',fontsize=6,rotation=-48)
text(17, 4e-2,'mesh spacing',fontsize=6,rotation=-21)
axis([1,2e3,1e-3,1e-1])
ylabel('Error', fontsize=10)
xlabel('Mesh density',fontsize=10)
subplots_adjust(left=0.22, bottom=0.21, right=0.96, top=0.95)
legend(loc='lower right')
savefig('Error_bpti_rec.pdf')
clf()

loglog(PyGerr_multi, timePyGmulti_rec, c='k', marker='o', mfc='w', ms=5, ls='-',lw=0.5,label='PyGBe mult')
loglog(PyGerr_singl, timePyGsingl_rec, c='k', marker='s', mfc='w', ms=5, ls='-',lw=0.5,label='PyGBe sing')
loglog(APBerr, timeAPB_rec, c='k', marker='^', mfc='w', ms=5, ls='-',lw=0.5,label='APBS')
subplots_adjust(left=0.19, bottom=0.21, right=0.96, top=0.95)
ylabel('Time to solution [s]',fontsize=10)
xlabel('Error',fontsize=10)
#axis([3e-3,1e-1,1e1,1e4])
legend(loc='upper right')
savefig('time_rec.pdf')
clf()


#### Ligand
PyGsolv_multi_ext_lig = -1216.02
PyGsolv_singl_ext_lig = -1219.93
APBsolv_ext_lig = -1218.86
semilogx(Elbem, EsolvPyGmulti_lig, c='k', marker='o', mfc='w', ms=3,ls='-',lw=0.5, label='PyGBe multi')
semilogx(Elbem, EsolvPyGsingl_lig, c='k', marker='s', mfc='w', ms=3,ls='-',lw=0.5, label='PyGBe single')
semilogx(Elfem, EsolvAPB_lig, c='k', marker='^', mfc='w', ms=3,ls='-',lw=0.5, label='APBS')

semilogx([xmin,xmax],PyGsolv_multi_ext_lig*ones(2), c='k', marker='', mfc='w', ms=1, ls='dotted',lw=0.2)
semilogx([xmin,xmax],PyGsolv_singl_ext_lig*ones(2), c='k', marker='', mfc='w', ms=1, ls='dotted',lw=0.2)
semilogx([xmin,xmax],APBsolv_ext_lig*ones(2), c='k', marker='', mfc='w', ms=1, ls='dotted',lw=0.2)
ylabel('$\Delta G_{solv}$ [kJ/mol]', fontsize=10)
xlabel('Mesh density',fontsize=10)
text(2, -1218.5,'APBS extrap.',fontsize=6,rotation=0)
text(50, -1225.5,'PyGBe single extrap.',fontsize=6,rotation=0)
text(40, -1215.5,'PyGBe multi extrap.',fontsize=6,rotation=0)
subplots_adjust(left=0.22, bottom=0.21, right=0.96, top=0.95)
axis([xmin,xmax,-1320,-1200])
legend(loc='lower right')
savefig('Esolv_bpti_lig.pdf')
clf()

APBerr = abs(EsolvAPB_lig-APBsolv_ext_lig)/abs(APBsolv_ext_lig)
PyGerr_multi = abs(EsolvPyGmulti_lig-PyGsolv_multi_ext_lig)/abs(PyGsolv_multi_ext_lig)
PyGerr_singl = abs(EsolvPyGsingl_lig-PyGsolv_singl_ext_lig)/abs(PyGsolv_singl_ext_lig)
loglog(Elbem, PyGerr_multi, c='k', marker='o', mfc='w', ms=3, ls='', lw=0.5, label='PyGBe mult')
loglog(Elbem, PyGerr_singl, c='k', marker='s', mfc='w', ms=3, ls='', lw=0.5, label='PyGBe sing')
loglog(Elfem, APBerr, c='k', marker='^', mfc='w', ms=3, ls='', lw=0.5, label='APBS')
loglog(Elbem, 1./Elbem*8e-2, c='k', marker='', mfc='w', ms=3, ls=':', lw=0.8, label=None)
loglog(Elfem, 1./(Elfem)**(1./3)*0.7e-1, c='k', marker='', mfc='w', ms=3, ls=':', lw=0.8, label=None)
text(1e1, 8e-3,'area',fontsize=6,rotation=-48)
text(11, 3.3e-2,'mesh spacing',fontsize=6,rotation=-20)
axis([1,2e3,1e-3,1e-1])
ylabel('Error', fontsize=10)
xlabel('Mesh density',fontsize=10)
subplots_adjust(left=0.22, bottom=0.21, right=0.96, top=0.95)
legend(loc='lower right')
savefig('Error_bpti_lig.pdf')
clf()

loglog(PyGerr_multi, timePyGmulti_lig, c='k', marker='o', mfc='w', ms=5, ls='-',lw=0.5,label='PyGBe mult')
loglog(PyGerr_singl, timePyGsingl_lig, c='k', marker='s', mfc='w', ms=5, ls='-',lw=0.5,label='PyGBe sing')
loglog(APBerr, timeAPB_lig, c='k', marker='^', mfc='w', ms=5, ls='-',lw=0.5,label='APBS')
subplots_adjust(left=0.19, bottom=0.21, right=0.96, top=0.95)
ylabel('Time to solution [s]',fontsize=10)
xlabel('Error',fontsize=10)
#axis([3e-3,1e-1,1e1,1e4])
legend(loc='lower left')
savefig('time_lig.pdf')
clf()
